use std::io;
use std::io::Write;
use std::net::{SocketAddr, TcpStream};

use messages::{any_as_u8_slice, Serializable};
use messages::client_registration::ClientRegistration;

fn main() -> io::Result<()> {
    let addr = SocketAddr::from(([127, 0, 0, 1], 4433));
    let mut stream = TcpStream::connect(addr)?;

    let registration = ClientRegistration {
        major_version: 0,
        minor_version: 0,
        name: "My new client :)".to_string(),
    };

    let mut buf = [0u8; 1024];
    registration.serialize(&mut buf);

    stream.write(&buf)?;

    Ok(())
}
